### This folder contains:

- #### FOCUS_calibration_tasmax.ipynb: 
    This vignette provides an example of code written in R that can be used to calibrate seasonal forecasts using several calibration methods (each one is explained in the calibration section).
    
    For each calibration method, the results and different skill scores are displayed and compared to the ones obtained by using a non-calibrated forecast. This example is conducted for a south-african domain along a reference period going from 1995 to 2015. 
    
    The vignette includes five main steps: (1) Loading R libraries, (2) Downloading the data and setting the configuration parameters, (3) Loading the seasonal data, (4) Calibrating the forecast and (5) Visualising the results.
   
    This vignette can be run interactively by just clicking on [![Binder](http://mybinder.org/badge_logo.svg)](https://mybinder.org/v2/gl/https%3A%2F%2Fearth.bsc.es%2Fgitlab%2Fexternal%2Fcstools/develop-CalibrationVignette?labpath=.%2Fbinder%2FFOCUS_calibration_tasmax.ipynb), thanks to [mybinder.org](mybinder.org), a free public service provided by the Jupyter community.

    If it is preferred, this vignette can be run in your computer through JupyterLab [https://jupyter.org/](https://jupyter.org/) , which is one of the latest web-based interactive development environment for notebooks, code, and data. We highly recommend to acces to the JupyterLab tool through the Aanaconda platform. Some details and a guide regarding the download and the installation can be found here [https://docs.conda.io/projects/conda/en/latest/user-guide/install/](https://docs.conda.io/projects/conda/en/latest/user-guide/install/).  
    
    Some requirements need to be met.

    R - version 3.6.1: It can be downloaded from https://cran.r-project.org/ . 

    CDO - version 1.9.8: It can be downloaded from https://code.mpimet.mpg.de/projects/cdo (with previous registration). Some useful information can be found on https://code.mpimet.mpg.de/projects/cdo/embedded/cdo.pdf , specially on the section 1.1. CDO should be loaded before conducting the analysis. 
    
- #### binder.png": 
    Screenshot with intructions to run the code interactively from mybinder.org
- #### environment.yml": 
    R environment - DO NOT DELETE!
- #### runtime.txt": 
    File that binder needs to run properly - DO NOT DELETE!
- #### vignette(number).png" : 
    Figures visualized in the vignette.
- #### vignette_tasmax_markdown.ipynb":
    Vignette to add to master
